#include <boost/python.hpp>
#include <boost/python/list.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/python/return_by_value.hpp>
#include <boost/python/return_value_policy.hpp>
#include <boost/python/register_ptr_to_python.hpp>
using namespace boost::python;

#include "alg/flp.hpp"
#include "alg/sequence.hpp"
#include "py/pythonsix.hpp"

struct listint_to_python {
  static PyObject *convert(const std::list<int> l) {
    PyObject *pylist = PyList_New(0);
    for(std::list<int>::const_iterator li = l.begin();
        li != l.end();
        ++li)
    {      
      PyList_Append(pylist, Integer_FromLong(*li));
    }
    return pylist;
  }
};

void export_flps()
{
  
  class_<FLPs>("FLP")
    .def("setup", &FLPs::setup, "set window size and lowest threshold")
    .def("seqcomp", &FLPs::seqcomp, "compare two sequences\n"
                                    "takes: sequence, seqeuence, bool is_reveresed flag")
    .def("size", &FLPs::size, "return the length of the sequence")
    .def("match_locations", &FLPs::match_locations, "return list of matches at a window location")
    .def("thres_matches", &FLPs::thres_matches, "return list of matches at a window location above a threshold")
  ;
    //std::list<match> matches(int index) const;    
    //void save(boost::filesystem::path save_file_path);
    //void load(boost::filesystem::path file_path);
  to_python_converter< std::list<int>, listint_to_python>();
}
