#ifndef _TEST_SEQUENCE_LOCATION_MODEL_HPP_
#define _TEST_SEQUENCE_LOCATION_MODEL_HPP_
#include "qui/subanalysis/SequenceLocationModel.hpp"
#include "alg/sequence_location.hpp"
#include "alg/sequence.hpp"

#include <QtTest/QtTest>

class TestSequenceLocationModel : public QObject
{
  Q_OBJECT

private slots:

  void testAddSequences() {
    Sequence seq1("AAGGCCTT");
    Sequence seq2("GGCCTTAA");

    SequenceLocation loc1(seq1, 0, 2);
    SequenceLocation loc2(seq2, 3, 3);

    SequenceLocationModel slm;
    QVERIFY(slm.size() == 0);
    slm.push_back(loc1);
    slm.push_back(loc2);

    QVERIFY(slm.rowCount() == 2);
    QVERIFY(slm.rowCount() == slm.size());

  }

  void testColumn() {
    SequenceLocationModel slm;
    QVERIFY(slm.columnCount() == 3);
  }
};
#endif
